#include<stdio.h>
#include<stdlib.h>
#include<time.h>
#define ROW 9
#define COL 9
#define CORRECT 0
#define WRONG -1
#define MAXNUM 1000 /*Ϸ, ڳʼ׶οһСһ100*/
int checkSudoku(const char a[][COL]){/**/
	int i,j,x,y;
	for( i = 0; i < ROW ; i++){
		for(j = 0 ; j < COL ; j++){
			for(x = 0 ; x < COL ; x++)
				if(a[i][x] == a[i][j] && x != j )
					return WRONG;

			for(x = 0 ; x < ROW ; x++)
				if(a[x][j] == a[i][j] && x != i )
					return WRONG;

			for(x = i/3*3 ; x < i/3*3+3 ; x ++)
				for(y = j/3*3 ; y < j/3*3+3 ; y++)
			 		if(a[x][y] == a[i][j] && (x != i && y != j))
					 	return WRONG;
		}
	}
	return CORRECT;
}
void printSudoku(const char a[][COL]){/*ӡ*/
	int i,j;
	printf("\n ЩЩ\n");
	for( i = 0 ; i < ROW ; i++){
		if(i != 0 && i%3 == 0) printf(" ੤੤\n");
		printf(" ");
		for( j = 0 ; j < COL ; j++){
			if(j != 0 && j%3 == 0) printf("  ");
			if(a[i][j])
				printf(" %d",a[i][j]);
			else printf("  ");
		}
		printf("  \n");
	}
	printf(" ةة\n");
}
void readFromFile(char a[][COL], const char filename[]){/*ļжȡ*/
	FILE * fp;
	if((fp = fopen(filename,"r")) == NULL){
		fprintf(stderr,"fail to open the file\n",filename);
		exit(EXIT_FAILURE);
	}
	int i,j;
	for( i = 0; i < ROW ; i++)
		for( j = 0; j < COL ; j++)
			fscanf(fp,"%d", &a[i][j]);
    free(fp);
	fclose(fp);

}
int Solve(const char a[][COL],char b[][COL], int i, int j){/*ݹaʾ̣bʾ⣬iʾУjʾ*/
	if(i < ROW && j < COL && i >= 0 && j >= 0){/*ڷΧ*/
		if(!a[i][j]){/*ǰԪ0ʾҪûȥ*/
			int x,y,k;
			char check[COL+1]={CORRECT};/*ųѾʹùĵ*/
			for(x = 0 ; x < COL ; x++)
				if(b[i][x]) check[b[i][x]] = WRONG;

			for(x = 0 ; x < ROW ; x++)
				if(b[x][j]) check[b[x][j]] = WRONG;

			for(x = i/3*3 ; x < i/3*3+3 ; x ++)
				for(y = j/3*3 ; y < j/3*3+3 ; y++)
			 		if(b[x][y]) check[b[x][y]] = WRONG;

			int flag = 0;//0ʾʧܣ1ʾɹ
			for(k = 1; k <= COL  && flag == 0 ; k++){/*checkвҰȫ*/
				if(check[k] == CORRECT){
					 flag = 1;
					 b[i][j] = k;
					 if( j == COL-1){
					 	if(Solve(a,b,i+1,0) == CORRECT) return CORRECT;
					 	else flag = 0; //ݹ麯WRONGflag±Ϊʧܣһε
					 }
					 else{
					 	if(Solve(a,b,i,j+1) == CORRECT) return CORRECT;
					 	else flag = 0;
					 }
				}
			}
			if(flag == 0){
				b[i][j] = 0;
				return WRONG;
			}
		}
		else{/*ǰλѾ֣һ*/
			if( j == COL-1){
				if(Solve(a,b,i+1,0) == CORRECT) return CORRECT;
				else return WRONG;
			}
			else{
				if(Solve(a,b,i,j+1) == CORRECT) return CORRECT;
				else return WRONG;
			}
		}
	}
	else return CORRECT;
}
/*
int dfs(int x,int y)
{
    int i;
    if(x==10)//
    {
        for(i=1;i<=9;i++)
        {
            for(int j=1;j<=9;j++)
                printf("%d",a[i][j]);
            printf("\n");
        }
        return 0;
    }

    if(a[x][y]==0)//жǷ
    {
        for(i=1;i<=9;i++)
        {
            if(judge(x,y,i))
            {
                a[x][y]=i;
                dfs(x+(y+1)/10,(y+1)%10);//һͷ
            }
        }
        a[x][y]=0;//
    }
    else
        dfs(x+(y+1)/10,(y+1)%10);//һ
    return 0;
}

bool judge(int i,int j,int num)//жǷ
{
    int k,x,y,l;
    if(i%3==0)  y=i/3;//óڼ飨ݣ
    else        y=i/3+1;

    if(j%3==0)  x=j/3;//óŵڼ
    else        x=j/3+1;

    for(k=1;k<=9;k++)//жһǷظ
        if(a[i][k]==num&&k!=j)   return false ;
    for(k=1;k<=9;k++)  //жһǷظ
        if(a[k][j]==num&&k!=i)   return false ;
    for(k=(y-1)*3+1;k<=y*3;k++)//жϸ÷Ƿظ
        for(l=(x-1)*3+1;l<=x*3;l++)
            if(a[k][l]==num&&k!=i&&l!=j)
                return false;
    return true;
}

*/
void solveSudoku(const char a[][COL], char b[][COL]){/**/
	// To Be Solved
	int i,j;
	for(i = 0; i < ROW ; i++)
		for(j = 0; j < COL; j++)
			b[i][j] = a[i][j];
	Solve(a,b,0,0);
}
int main(){
	char starting_grid[ROW][COL]={0};
	char result[ROW][COL]={0};
	char filename[50];
	int rr;
	double time_from, time_to, time_sum = 0;
	int i;
	for( i = 0; i < MAXNUM; i++){
		sprintf(filename,"sudoku\\%04d.txt",i);
		readFromFile(starting_grid,filename);
		printf("\n\n             *%4d  *",i);
		printSudoku(starting_grid);
		time_from = clock();
		solveSudoku(starting_grid,result);
		time_to = clock();
		time_sum += time_to - time_from;
		printSudoku(result);
		rr = checkSudoku(result);
		if( rr == WRONG){
			printf("Something goes wrong...\n");
			return WRONG;
		}
		else printf("            Correct!!!\n");
		printf("  ==============================");
	}
	printf("\n Congretulations! ToTal Time:%fs\n",time_sum / CLOCKS_PER_SEC);
	return 0;
}
